#ifndef	_LINUX_H
#define	_LINUX_H
#define _HARDWARE_H

/*
 * Making a very PC-hardware-oriented program work under Linux is, to say the
 * least, interesting.
 */

#ifndef	_GLOBAL_H
#include "global.h"
#endif

#include <ctype.h>

struct session;

struct screen {
#ifdef SCREEN_INTERNAL
	WINDOW *win;		/* window for session */
	/* WATCH THIS SPACE!!!  External sessions coming soon! */
#else
	int dontlookatthis[1];
#endif
};
#define	NULLSCREEN	(struct screen *)0

/* from linux.c */
extern void register_io __ARGS((int fd, void *event));
extern void unregister_io __ARGS((int fd));
extern long filelength __ARGS((int fd));
#ifdef NEED_STRCASECMP
extern int strcasecmp __ARGS((char *s1, char *s2));
#endif
#ifdef NEED_STRNCASECMP
extern int strcasecmp __ARGS((char *s1, char *s2));
#endif
extern unsigned long farcoreleft __ARGS((void));
extern unsigned long getss __ARGS((void));
extern void init_sys __ARGS((void));
extern void deinit_sys __ARGS((void));
extern void giveup __ARGS((void));

/* from curses.c */
extern void ioinit __ARGS((void));
extern void iostop __ARGS((void));
extern void swapscreen __ARGS((struct session *old, struct session *new));
extern void putch __ARGS((int c));
extern void sputch __ARGS((struct session *, int));
extern void cputs __ARGS((char *));
extern void scputs __ARGS((struct session *, char *));
extern void clreol __ARGS((void));
extern void sclreol __ARGS((struct session *));
extern void rflush __ARGS((void));
extern void j_newscreen __ARGS((struct session *));
extern void freescreen __ARGS((struct session *));
extern void clrscr __ARGS((void));
extern int wherex __ARGS((void));
extern int wherey __ARGS((void));
extern void window __ARGS((int, int, int, int));
extern void gotoxy __ARGS((int, int));
extern void highvideo __ARGS((void));
extern void normvideo __ARGS((void));
extern void _setcursortype __ARGS((int));
extern int kbread __ARGS((void));
extern void detach_all_asy __ARGS((void));

/*
 * unix functions - can't include system headers or we'll have major collisions
 * because JNOS usurps e.g. all the socket and timer calls
 */
extern int getpid __ARGS((void));
#ifdef linux
extern int unlink __ARGS((char *));
#endif
extern int fork __ARGS((void));
extern int execvp __ARGS((char *, char **));
extern int lseek __ARGS((int, long, int));
extern int read __ARGS((int, void *, unsigned));
extern int close __ARGS((int));
extern int access __ARGS((char *, int));
extern int write __ARGS((int, void *, unsigned));
extern char *getcwd __ARGS((char *, int));

#ifndef SCREEN_INTERNAL
#define newscreen j_newscreen
#endif

#define _NOCURSOR 0
#define _SOLIDCURSOR 2
#define _NORMALCURSOR 1

#endif	/* _LINUX_H */
